<?php
/*
Plugin Name: ELI's Related Posts Footer Links and Widget
Plugin URI: http://wordpress.ieonly.com/category/my-plugins/related-posts-widget/
Author: Eli Scheetz
Author URI: http://wordpress.ieonly.com/
Description: This Plugin con creates links to Related Post at the bottom of every post. There is also a Widget for your WordPress sidebar or footer area. Links can be displayed in a Tree View or as a Simple List and can be related by Tags or by Category.
Version: 1.2.01.09
*/
$SPOSTARBUST_Version='1.2.01.09';
$_SESSION['eli_debug_microtime']['include(SPOSTARBUST)'] = microtime(true);
$SPOSTARBUST_plugin_dir='SPOSTARBUST';
/**
 * SPOSTARBUST Main Plugin File
 * @package SPOSTARBUST
*/
/*  Copyright 2011 Eli Scheetz (email: wordpress@ieonly.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function SPOSTARBUST_install() {
	global $wp_version;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_install_start'] = microtime(true);
	if (version_compare($wp_version, "2.6", "<")) {
		die(__("This Plugin requires WordPress version 2.6 or higher"));
	}
$_SESSION['eli_debug_microtime']['SPOSTARBUST_install_end'] = microtime(true);
}
function SPOSTARBUST_display_header($pTitle) {
	global $SPOSTARBUST_plugin_dir, $SPOSTARBUST_plugin_home, $SPOSTARBUST_updated_images_path, $SPOSTARBUST_Version;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_header_start'] = microtime(true);
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
	$wait_img_URL = $SPOSTARBUST_settings_array['img_url'].'wait.gif';
	echo '<style>
	.rounded-corners {margin: 10px; padding: 10px; -webkit-border-radius: 10px; -moz-border-radius: 10px; border: 1px solid #000000;}
	.shadowed-box {box-shadow: -3px 3px 3px #666666; -moz-box-shadow: -3px 3px 3px #666666; -webkit-box-shadow: -3px 3px 3px #666666;}
	.sidebar-box {background-color: #CCCCCC;}
	.shadowed-text {text-shadow: #0000FF -1px 1px 1px;}
	#right-sidebar {float: right; width: 230px;}
	#main-section {margin-right: 250px;}
	</style>
	<h1>ELI\'s Related Posts '.$pTitle.'</h1>
	<div id="right-sidebar">
	<div id="pluginupdates" class="shadowed-box rounded-corners sidebar-box"><center><h3 class="shadowed-text">Plugin Updates</h3></center>
		<div id="findUpdates"><center>Searching for updates ...<br /><img src="'.$wait_img_URL.'" alt="Wait..." /><br /><input type="button" value="Cancel" onclick="document.getElementById(\'findUpdates\').innerHTML = \'Could not find server!\';" /></center></div>
	<script type="text/javascript" src="'.$SPOSTARBUST_plugin_home.$SPOSTARBUST_updated_images_path.'?js='.$SPOSTARBUST_Version.'&p='.$SPOSTARBUST_plugin_dir.'"></script>
	</div>
	<div id="pluginlinks" class="shadowed-box rounded-corners sidebar-box"><center><h3 class="shadowed-text">Plugin Links</h3>
<table><tr><td>
<li><a target="_blank" href="'.$SPOSTARBUST_plugin_home.'category/my-plugins/related-posts-widget/">Plugin URI</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/'.strtolower($SPOSTARBUST_plugin_dir).'/faq/">Plugin FAQs</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/'.strtolower($SPOSTARBUST_plugin_dir).'/stats/">Download Stats</a>
<li><a target="_blank" href="http://wordpress.org/tags/'.strtolower($SPOSTARBUST_plugin_dir).'">Forum Posts</a>
</td></tr></table>
</center></div>
	<div id="authorlinks" class="shadowed-box rounded-corners sidebar-box"><center><h3 class="shadowed-text">Author Links</h3>Feed My Family:<br /><form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="8VWNB5QEJ55TJ">
<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
<table><tr><td>
<li><a target="_blank" href="'.$SPOSTARBUST_plugin_home.'category/my-plugins/">ELI\'s Blog</a>
<li><a target="_blank" href="http://wordpress.org/extend/plugins/profile/scheeeli">WordPress Profile</a>
</td></tr></table>
</center></div>
	</div>
	<div id="admin-page-container">
	<div id="main-section">';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_header_end'] = microtime(true);
}
function SPOSTARBUST_display_File($dFile) {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_File_start'] = microtime(true);
	if (file_exists(dirname(__FILE__).'/'.strtolower($dFile).'.txt')) {
		echo '<h2>'.$dFile.' File</h2><textarea disabled="yes" width="100%" style="width: 100%;" rows="20" class="shadowed-box">';
		include(strtolower($dFile).'.txt');
		echo '</textarea><br />';
	}
$_SESSION['eli_debug_microtime']['SPOSTARBUST_display_File_end'] = microtime(true);
}
function SPOSTARBUST_Settings() {
	global $SPOSTARBUST_SQL_SELECT, $SPOSTARBUST_plugin_dir, $SPOSTARBUST_images_path;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Settings_start'] = microtime(true);
	SPOSTARBUST_display_header('Settings');
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
	if (!isset($SPOSTARBUST_settings_array['linklist_title']))
		$SPOSTARBUST_settings_array['linklist_title'] = "Related Posts";
	if (!(isset($SPOSTARBUST_settings_array['auto_relate']) && strlen($SPOSTARBUST_settings_array['auto_relate'])>0))
		$SPOSTARBUST_settings_array['auto_relate'] = "no";
	if (!isset($SPOSTARBUST_settings_array['link_count']))
		$SPOSTARBUST_settings_array['link_count'] = 5;
	if (isset($_POST['link_count']) && is_numeric($_POST['link_count']) && $_POST['link_count'] != $SPOSTARBUST_settings_array['link_count'])
		$SPOSTARBUST_settings_array['link_count'] = $_POST['link_count'];
	if (isset($_POST['auto_relate']) && $_POST['auto_relate'] != $SPOSTARBUST_settings_array['auto_relate'])
		$SPOSTARBUST_settings_array['auto_relate'] = $_POST['auto_relate'];
	if (isset($_POST['linklist_title']) && $_POST['linklist_title'] != $SPOSTARBUST_settings_array['linklist_title'])
		$SPOSTARBUST_settings_array['linklist_title'] = $_POST['linklist_title'];
	if (!isset($SPOSTARBUST_settings_array['relate_by']))
		$SPOSTARBUST_settings_array['relate_by'] = "tag__in";
	if (isset($_POST['relate_by']) && $_POST['relate_by'] != $SPOSTARBUST_settings_array['relate_by'])
		$SPOSTARBUST_settings_array['relate_by'] = $_POST['relate_by'];
	update_option($SPOSTARBUST_plugin_dir.'_settings_array', $SPOSTARBUST_settings_array);
	$checked = array('yes'=>'','no'=>'');
	$checked[$SPOSTARBUST_settings_array['auto_relate']] = ' checked';
	$display = array('yes'=>'block','no'=>'none');
	echo '<script>
	function setDisplay(dis_yn) {
		document.getElementById(\'yessettings\').style.display = dis_yn;
	}
</script><form method="POST" name="SPOSTARBUST_Form"><div class="shadowed-box rounded-corners" style="background-color: #FFFFCC;"><b>Automatically add links to related Posts at the bottom of every Post?</b><hr /><input type="radio" name="auto_relate" value="no"'.$checked["no"].' onchange="setDisplay(\''.$display["no"].'\');" /><b>no</b> &nbsp; (Use this setting if you plan to use the Widget)<hr /><input type="radio" name="auto_relate" value="yes"'.$checked["yes"].' onchange="setDisplay(\''.$display["yes"].'\');" /><b>yes</b> &nbsp; (Use this setting and you don\'t need the Widget)<br /><div id="yessettings" style="padding: 0 0 0 40px; display: '.$display[$SPOSTARBUST_settings_array['auto_relate']].';"><br />Title for the Related Posts list:<br /><input type="text" name="linklist_title" value="'.$SPOSTARBUST_settings_array['linklist_title'].'" /><br /><br />Relate Posts by:<br /><select name="relate_by"><option value="tag__in">Tags</option><option value="category__in"'.($SPOSTARBUST_settings_array['relate_by']=="category__in"?" selected":"").'>Categories</option></select><br /><br />Number of Related Posts to display: <input type="text" size="3" name="link_count" value="'.$SPOSTARBUST_settings_array['link_count'].'" /><br /></div><hr /><br /><input type="submit" value="Save Changes" class="button-primary" /></div>
</form></div></div>';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Settings_end'] = microtime(true);
}
function SPOSTARBUST_debug($my_error = '', $echo_error = false) {
	global $SPOSTARBUST_plugin_dir, $SPOSTARBUST_Version, $wp_version;
	$mtime=date("Y-m-d H:i:s", filemtime(__file__));
	if ($echo_error)
		echo "<li>debug:<pre>$my_error\n".print_r($_SESSION['eli_debug_microtime'],true).'END;</pre>';
	else mail("wordpress@ieonly.com", "SPOSTARBUST $SPOSTARBUST_Version ERRORS", "mtime=$mtime\nwp_version=$wp_version\n$my_error\n".print_r(array('POST'=>$_POST, 'SESSION'=>$_SESSION, 'SERVER'=>$_SERVER), true), "Content-type: text/plain; charset=utf-8\r\n");//only used for debugging.//rem this line out
	$_SESSION['eli_debug_microtime']=array();
}
function SPOSTARBUST_readme_license() {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_readme_license_start'] = microtime(true);
	SPOSTARBUST_display_header('Readme & License');
	SPOSTARBUST_display_File('Readme');
	SPOSTARBUST_display_File('License');
	echo '</div></div>';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_readme_license_end'] = microtime(true);
}
function SPOSTARBUST_menu() {
	global $SPOSTARBUST_plugin_dir, $SPOSTARBUST_Version, $wp_version, $SPOSTARBUST_plugin_home, $SPOSTARBUST_Logo_IMG, $SPOSTARBUST_updated_images_path;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_menu_start'] = microtime(true);
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
	$Logo_URL = $SPOSTARBUST_settings_array['img_url'].$SPOSTARBUST_Logo_IMG;
	$img_path = basename(__FILE__);
	$Logo_Path = 'images/'.$SPOSTARBUST_Logo_IMG;
	$Full_plugin_logo_URL = get_option('siteurl');
	$Full_plugin_logo_URL = $SPOSTARBUST_plugin_home.$SPOSTARBUST_updated_images_path.$img_path.'?v='.$SPOSTARBUST_Version.'&wp='.$wp_version.'&p='.$SPOSTARBUST_plugin_dir.'&d='.
	urlencode($Full_plugin_logo_URL);
	$Logo_URL = $Full_plugin_logo_URL;
	$base_page = $SPOSTARBUST_plugin_dir.'-settings';
	if (function_exists('add_object_page'))
		add_object_page(__('ELI\'s Related Posts - Settings'), __('RelatedPosts'), 'administrator', $base_page, $SPOSTARBUST_plugin_dir.'_settings', $Logo_URL);
	else
		add_menu_page(__('ELI\'s Related Posts - Settings'), __('RelatedPosts'), 'administrator', $base_page, $SPOSTARBUST_plugin_dir.'_settings', $Logo_URL);
	add_submenu_page($base_page, __('ELI\'s Related Posts - Settings Page'), __('Settings'), 'administrator', $base_page, $SPOSTARBUST_plugin_dir.'_settings');
	add_submenu_page($base_page, __('ELI\'s Related Posts - Readme &amp; License File'), __('Readme &amp; License'), 'administrator', $SPOSTARBUST_plugin_dir.'-readme-license', $SPOSTARBUST_plugin_dir.'_readme_license');
$_SESSION['eli_debug_microtime']['SPOSTARBUST_menu_end'] = microtime(true);
}
function SPOSTARBUST_query_related_posts($number, $relateby, $tag_IDs, $post_IDs) {
	global $post;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_query_related_posts_start'] = microtime(true);
	$tags_query = array('showposts' => $number, $relateby => $tag_IDs, 'post__not_in' => $post_IDs);
	query_posts($tags_query);
	$LIs = '';
	for ($p = 0; have_posts(); $p++) {
		the_post();
		if (!in_array($post->ID, $post_IDs))
			$LIs .= the_title('<li class="SPOSTARBUST-Related-Post"><a title="', '" href="', false).get_permalink($post->ID).the_title('" rel="bookmark">', "</a></li>\n", false);
	}
$_SESSION['eli_debug_microtime']['SPOSTARBUST_query_related_posts_end'] = microtime(true);
	return $LIs;
}
function SPOSTARBUST_init() {
	global $SPOSTARBUST_plugin_dir;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_init_start'] = microtime(true);
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
	$SPOSTARBUST_settings_array["img_url"]=plugins_url('/images/', __FILE__);	
	update_option($SPOSTARBUST_plugin_dir.'_settings_array', $SPOSTARBUST_settings_array);
$_SESSION['eli_debug_microtime']['SPOSTARBUST_init_end'] = microtime(true);
}
function SPOSTARBUST_related_links_on_posts($the_content) {
	global $SPOSTARBUST_plugin_dir, $post;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_related_links_on_posts_start'] = microtime(true);
	$SPOSTARBUST_settings_array = get_option($SPOSTARBUST_plugin_dir.'_settings_array');
//		$the_content .= 'pre ';
	if ((!is_page()) && isset($SPOSTARBUST_settings_array['auto_relate']) && ($SPOSTARBUST_settings_array['auto_relate'] == "yes")) {
//		$the_content .= 'if ';
		$the_content .= '<ul class="comment">';
		if (isset($SPOSTARBUST_settings_array['linklist_title']))
			$the_content .= '<h3>'.$SPOSTARBUST_settings_array['linklist_title'].'</h3>';
		if (!(isset($SPOSTARBUST_settings_array['link_count']) && is_numeric($SPOSTARBUST_settings_array['link_count'])))
			$SPOSTARBUST_settings_array['link_count'] = 5;
		$global_post = $post;
	//	wp_reset_query();
		//if (have_posts()) {
			//the_post();
		$pID = $post->ID;
		if (isset($SPOSTARBUST_settings_array['relate_by']) && $SPOSTARBUST_settings_array['relate_by'] == "category__in")
			$all_tags = get_the_category();
		else {
			$all_tags = get_the_tags();
			$SPOSTARBUST_settings_array['relate_by'] = "tag__in";
		}
		if ($all_tags)
			foreach ($all_tags as $tag)
				$tags[] = $tag->term_id;
		if (count($tags) > 0) {
			$tags_query = array('showposts' => $SPOSTARBUST_settings_array['link_count'], $SPOSTARBUST_settings_array['relate_by'] => $tags,'post__not_in' => array("$pID"));
			query_posts($tags_query);
			$LIs = '';
			for ($p = 0; have_posts() && ($p <= $SPOSTARBUST_settings_array['link_count']); $p++) {
//	$LIs .= '<li>'.$p.'</li>';
				the_post();
				if ($pID != $post->ID)
					$LIs .= the_title('<li class="SPOSTARBUST-Related-Post"><a title="', '" href="', false).get_permalink($post->ID).the_title('" rel="bookmark">', "</a></li>\n", false);
			}
			if (strlen($LIs) > 0)
				$the_content .= $LIs;
		}
		wp_reset_postdata();
		wp_reset_query();
		$post = $global_post;

//		for ($link = 0; $link < $SPOSTARBUST_settings_array['link_count']; $link++) {
	//		$the_content .= '<li>'.$pID.'['.$link.']</li>';
		//}
		$the_content .= '</ul>';
	}// else $the_content .= 'else ';
$_SESSION['eli_debug_microtime']['SPOSTARBUST_related_links_on_posts_end'] = microtime(true);
	return $the_content;
}
class SPOSTARBUST_Widget_Class extends WP_Widget {
	function SPOSTARBUST_Widget_Class() {
		global $SPOSTARBUST_plugin_dir;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_Widget_Class_start'] = microtime(true);
		$this->WP_Widget($SPOSTARBUST_plugin_dir.'-Widget', __('ELI\'s Related Posts'), array('classname' => 'widget_'.$SPOSTARBUST_plugin_dir, 'description' => __('Linked list of related Posts by Tags or Categories')));
		$this->alt_option_name = 'widget_'.$SPOSTARBUST_plugin_dir;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_Widget_Class_end'] = microtime(true);
	}
	function widget($args, $instance) {
		global $post;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_widget_start'] = microtime(true);
		$global_post = $post;
		wp_reset_query();
		$p_count = 0;
		if (have_posts()) {
			$tags = array();
			$pID = array();
			extract($args);
			if (!$instance['title'])
				$instance['title'] = "Related Posts";
			if (!$instance['number'])
				$instance['number'] = 5;
			if (isset($instance['treeview']) && ($instance['treeview'] == 'yes'))
				$instance['singleonly'] = (isset($instance['singleonly']) && ($instance['singleonly'] == 'yes')) ? 'yes' : 'no';
			else
				$instance['singleonly'] = 'yes';
			do {
				the_post();
				$pID[] = $post->ID;
				if (isset($instance['relateby']) && $instance['relateby'] == "category__in")
					$all_tags = get_the_category();
				else {
					$all_tags = get_the_tags();
					$instance['relateby'] = "tag__in";
				}
				if ($all_tags)
					foreach ($all_tags as $tag)
						$tags[''.$tag->term_id] = $tag->name;
				$p_count++;	
			} while (have_posts());
//echo '<li>p='.$p_count;
			$tag_count = count($tags);
//echo '<li>t='.$tag_count;
			if ((($p_count == 1) || ($instance['singleonly'] == 'no')) && ($tag_count > 0)) {
				$LIs = '';
				if (isset($instance['treeview']) && ($instance['treeview'] == 'yes')) {
					$LIa = array();
					$LIc = array();
					foreach ($tags as $tag_ID => $tag_Name) {
						$tag_ID = explode("\n", "\n".SPOSTARBUST_query_related_posts($instance['number'] * $tag_count, $instance['relateby'], array("$tag_ID"), $pID));
						if (count($tag_ID) > 2) {
							unset($tag_ID[count($tag_ID)-1]);
							unset($tag_ID[0]);
							foreach ($tag_ID as $tID)
								$LIa["<li>".$tag_Name."<ul>"][$tID] = 0;
							$LIc["<li>".$tag_Name."<ul>"] = count($tag_ID);
						}
					}
					do {
						asort($LIc);
						$find = array_keys($LIc);
						$aN = 0;
						while ($aN < count($find)) {
							$isFound = false;
//echo '<li>'.$aN.'&lt;'.count($find).'<ul>';
							foreach ($LIa as $tag_group => $tag_list) {
//echo $tag_group;
								if (($find[$aN] != $tag_group) && (!$isFound)) {
									$tag_items = array_keys($tag_list);
//echo $find[$aN];
									$find_items = array_keys($LIa[$find[$aN]]);
									for ($iN = 0; ($iN < count($find_items)) && (!$isFound); $iN++) {
//echo '<li>'.$iN.'&lt;'.count($find_items).'<ul>';
										if (in_array($find_items[$iN], $tag_items)) {
//echo $find_items[$iN];
											$isFound = true;
											$LIa[$find[$aN]][$find_items[$iN]]++;
//echo '<li>'.$LIa[$find[$aN]][$find_items[$iN]];
											unset($LIa[$tag_group][$find_items[$iN]]);
											$LIc[$tag_group]--;
//echo '<li>'.$LIc[$tag_group];
											asort($LIc);
											$find = array_keys($LIc);
										}
//echo '</ul></li>';
									}
//echo '</ul></li>';
								}
//echo '</ul></li>';
							}
							if ($isFound)
								$aN = 0;
							else
								$aN++;
//echo '</ul></li>';
						}
					} while ($isFound);
					foreach ($LIa as $tag_group => $tag_list) {
						arsort($tag_list);
						$tag_items = array_keys($tag_list);
						$LIs .= $tag_group.implode("\n", array_slice($tag_items, 0, $instance['number']))."</ul></li>";
					}
				} else
					$LIs = SPOSTARBUST_query_related_posts($instance['number'], $instance['relateby'], array_keys($tags), $pID);
//echo '<li>strlen(LIs)='.strlen($LIs);
				if (strlen($LIs) > 0)
					echo $before_widget.$before_title.$instance["title"].$after_title."<ul>\n".$LIs."</ul>\n".$after_widget;
			}// else echo '<li>else singleonly='.$instance['singleonly'];
		}
		wp_reset_query();
		$post = $global_post;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_widget_end'] = microtime(true);
//SPOSTARBUST_debug($p_count." posts ".print_r($LIa, true));
	}
	function flush_widget_cache() {
		global $SPOSTARBUST_plugin_dir;
		wp_cache_delete('widget_'.$SPOSTARBUST_plugin_dir, 'widget');
	}
	function update($new, $old) {
		$instance = $old;
		$instance['title'] = strip_tags($new['title']);
		$instance['number'] = (int) $new['number'];
		$instance['relateby'] = strip_tags($new['relateby']);
		if (isset($new['treeview']) && ($new['treeview'] == 'yes')) {
			$instance['treeview'] = 'yes';
			$instance['singleonly'] = isset($new['singleonly']) ? esc_attr($new['singleonly']) : 'no';
		} else {
			$instance['treeview'] = 'no';
			$instance['singleonly'] = 'yes';
		}
		return $instance;
	}
	function form( $instance ) {
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_form_start'] = microtime(true);
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$relateby = isset($instance['relateby']) ? esc_attr($instance['relateby']) : 'tag__in';
		if (isset($instance['treeview']) && ($instance['treeview'] == 'yes')) {
			$treeviewyes = ' checked';
			$singleonly = isset($instance['singleonly']) ? esc_attr($instance['singleonly']) : 'yes';
		} else {
			$treeviewno = ' checked';
			$singleonly = 'yes';
			$js = '<script>document.getElementById(\''.$this->get_field_id('singleonly').'\').disabled=true;document.getElementById(\''.$this->get_field_id('singleonly').'\').checked=true;</script>';
		}
		echo '<p><label for="'.$this->get_field_id('title').'">'.__('Alternative Title').':</label>
		<input type="text" name="'.$this->get_field_name('title').'" id="'.$this->get_field_id('title').'" value="'.$title.'" /></p>
		<p><label for="'.$this->get_field_id('relateby').'">'.__('Relate Posts by').':</label>
		<select name="'.$this->get_field_name('relateby').'" id="'.$this->get_field_id('relateby').'"><option value="tag__in">Tags</option><option value="category__in"'.($relateby=="category__in"?" selected":"").'>Categories</option></select></p>
		<p><label for="'.$this->get_field_id('number').'">Number of Posts to List:</label>
		<input type="text" size="2" name="'.$this->get_field_name('number').'" id="'.$this->get_field_id('number').'" value="'.$number.'" /></p>
		<p><input type="radio" name="'.$this->get_field_name('treeview').'" id="'.$this->get_field_id('treeview').'" value="no"'.$treeviewno.' onchange="document.getElementById(\''.$this->get_field_id('singleonly').'\').disabled=true;document.getElementById(\''.$this->get_field_id('singleonly').'\').checked=true;" /><b>Clasic View</b> - Sigle-column list<br />(The Widget will only show on pages that display a single post)<hr /><input type="radio" name="'.$this->get_field_name('treeview').'" id="'.$this->get_field_id('treeview').'" value="yes"'.$treeviewyes.' onchange="document.getElementById(\''.$this->get_field_id('singleonly').'\').disabled=false;" /><b>Tree View</b> - List Realated Posts under each Tag or Category<br />("Number of Posts to List" then applies to each tag list or category list in the hierarchy)<dd><input type="checkbox" name="'.$this->get_field_name('singleonly').'" id="'.$this->get_field_id('singleonly').'" value="yes"'.($singleonly=="yes"?" checked":"").' /><label for="'.$this->get_field_id('singleonly').'">'.__('Only show on pages with a single post').'</label></p>'.$js;
$_SESSION['eli_debug_microtime']['SPOSTARBUST_Widget_Class_form_end'] = microtime(true);
	}
}
function SPOSTARBUST_set_plugin_action_links($links_array, $plugin_file) {
	if ($plugin_file == substr(__file__, (-1 * strlen($plugin_file)))) {
		$_SESSION['eli_debug_microtime']['SPOSTARBUST_set_plugin_action_links'] = microtime(true);
		$links_array = array_merge(array('<a href="admin.php?page=SPOSTARBUST-settings">'.__( 'Settings' ).'</a>'), $links_array);
	}
	return $links_array;
}
function SPOSTARBUST_set_plugin_row_meta($links_array, $plugin_file) {
	if ($plugin_file == substr(__file__, (-1 * strlen($plugin_file)))) {
		$_SESSION['eli_debug_microtime']['SPOSTARBUST_set_plugin_row_meta'] = microtime(true);
		$links_array = array_merge($links_array, array('<a target="_blank" href="http://wordpress.org/extend/plugins/spostarbust/faq/">'.__( 'FAQ' ).'</a>','<a target="_blank" href="http://wordpress.org/tags/spostarbust">'.__( 'Support' ).'</a>','<a target="_blank" href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=8VWNB5QEJ55TJ">'.__( 'Donate' ).'</a>'));
	}
	return $links_array;
}
add_filter('plugin_row_meta', $SPOSTARBUST_plugin_dir.'_set_plugin_row_meta', 1, 2);
add_filter('plugin_action_links', $SPOSTARBUST_plugin_dir.'_set_plugin_action_links', 1, 2);
$SPOSTARBUST_plugin_home='http://wordpress.ieonly.com/';
$SPOSTARBUST_updated_images_path='wp-content/plugins/update/images/';
$SPOSTARBUST_Logo_IMG='SPOSTARBUST-16x16.gif';
register_activation_hook(__FILE__,$SPOSTARBUST_plugin_dir.'_install');
add_action('widgets_init', create_function('', 'return register_widget("SPOSTARBUST_Widget_Class");'));
add_action('admin_init', $SPOSTARBUST_plugin_dir.'_init');
add_action('admin_menu', $SPOSTARBUST_plugin_dir.'_menu');
add_filter('the_content', $SPOSTARBUST_plugin_dir.'_related_links_on_posts');
$_SESSION['eli_debug_microtime']['end_include(SPOSTARBUST)'] = microtime(true);
?>
